unit opatest;

{$MODE Delphi}

interface

uses OPAglobal, OpticPlot, asaux, sysutils, Classes, strutils, dialogs, mathlib;

 procedure readkvalues;
 procedure magparams;
 procedure madseqconvert(seqfile:string; var TextBuffer: pointer);
 procedure madconvert(madfile:string; var TextBuffer: pointer);
 procedure lteconvert(ltefile:string; var TextBuffer: pointer);
 procedure undulator_export;
 procedure bdpattern_export;
 procedure ele_aper_export;

//procedure Ctouschek_table;
//procedure Eulertest;
//procedure VZlineup;
//procedure indexxtest;
//procedure kickerbump3;
//function combination(n,k: integer): double;


implementation

procedure Readkvalues;

const
//  csmul=1.1345;
  csmul=-1.0;
  qamul=1.0;
  csfile='b073_skew';
  qafile='nonexistent';
//  qafile='ID_corr_1';
//  csfile='skew_1';

var
 tfIn: textfile;
 line, kfile, nind, sval: string;
 err, nco,j: integer;
 kval: real;

begin

  kfile:=work_dir+csfile+'.out';
  AssignFile(tfIn, kfile);
  try
    reset(tfIn);
    // Keep reading lines until the end of the file is reached
    nco:=0;
    while not Eof(tfIn) do begin
      readln(tfIn, line);
      if Pos('#',line)=0 then begin
        nind:=Extractword(1,line,[' ']);
        while length(nind)<3 do nind:='0'+nind;
        nind:=oco_csname+nind;
//        writeln(diagfil, nind);
        for j:=1 to Glob.Nella do if Ella[j].cod=cquad then if Ella[j].nam=nind then begin
          sval:=Extractword(4,line,[' ']);
          {$R-}
          Val(sval,kval,err);
          {$R+}
          if err<>0 then kval:=0 else inc(nco);
kval:=kval*csmul;
          if Ella[j].l>1e-6 then Ella[j].kq:=kval/Ella[j].l;
//          writeln(Ella[j].nam, ' ', Ella[j].kq);
        end;
      end;
    end;
    CloseFile(tfIn);
    MessageDlg(inttostr(nco)+' k-values read from '+kfile, MtInformation, [mbOK],0);
  except
    on E: EInOutError do
    MessageDlg('Could not read '+kfile+'. '+E.Message, MtError, [mbOK],0);
  end;

  kfile:=work_dir+qafile+'.out';
  AssignFile(tfIn, kfile);
  try
    reset(tfIn);
    // Keep reading lines until the end of the file is reached
    nco:=0;
    while not Eof(tfIn) do begin
      readln(tfIn, line);
      if Pos('#',line)=0 then begin
        nind:=Extractword(2,line,[' ']);
        while length(nind)<3 do nind:='0'+nind;
        nind:=oco_qaname+nind;
//        writeln(diagfil, nind);
        for j:=1 to Glob.Nella do if Ella[j].cod=cquad then if Ella[j].nam=nind then begin
          sval:=Extractword(3,line,[' ']);
          {$R-}
          Val(sval,kval,err);
          {$R+}
          if err<>0 then kval:=0 else inc(nco);
kval:=kval*qamul;
          if Ella[j].l>1e-6 then Ella[j].kq:=kval/Ella[j].l;
//          Ella[j].kq:=kval;
//          writeln(Ella[j].nam, ' ', Ella[j].kq);
        end;
      end;
    end;
    CloseFile(tfIn);
    MessageDlg(inttostr(nco)+' k-values read from '+kfile, MtInformation, [mbOK],0);
  except
    on E: EInOutError do
    MessageDlg('Could not read '+kfile+'. '+E.Message, MtError, [mbOK],0);
  end;

end;

procedure MagParams;
const
  Cmagparam: array [0..8] of integer =
    (Cbend,Ccomb,Cquad,Csole,Csext,Cmpol,Csept,Ckick,Cundu);
  mpolnam: array[1..6] of elemstr =
    ('dipole','quadrupole','sextupole','octupole','decapole','dodecapole');
var
  i, j: integer;
  brho: real;
  fname, mnam, smpm, smpm1, smpm2: string;
  fo: textfile;
begin
  fname:=ExtractFileName(FileName);
  fname:=work_dir+Copy(fname,0,Pos('.',fname)-1)+'_magpar.txt';
  assignFile(fo,fname);
  try
    rewrite(fo);
    brho:=glob.energy*1E9/speed_of_light;
    for i:=0 to 8 do begin
      for j:=1 to Glob.NElem do with Elem[j] do if cod = Cmagparam[i] then begin
        case cod of
          cbend: begin
            writeln(fo); writeln(fo,Nam+': bending magnet');
            writeln(fo, '  arc length [m]   = ', l:9:6);
            writeln(fo, '  angle      [deg] = ', phi*degrad:9:6);
            writeln(fo, '  entry edge [deg] = ', tin*degrad:9:6);
            writeln(fo, '  exit  edge [deg] = ', tex*degrad:9:6);
            writeln(fo, '  full gap   [mm]  = ', gap*1000:8:3);
            writeln(fo, '  entry fringe K1  = ', k1in:6:3);
            writeln(fo, '  entry fringe K2  = ', k2in:6:3);
            writeln(fo, '  exit  fringe K1  = ', k1ex:6:3);
            writeln(fo, '  exit  fringe K2  = ', k2ex:6:3);
            writeln(fo, '  field B     [T]  = ', phi/l*brho:9:5);
            writeln(fo, '  gradient B''[T/m] = ', kb*brho:9:4);
          end;
          ccomb: begin
            writeln(fo); writeln(fo,Nam+': combined function ');
            writeln(fo, '  arc length [m]   = ', l:9:6);
            writeln(fo, '  angle      [deg] = ', cphi*degrad:9:6);
            writeln(fo, '  entry edge [deg] = ', cerin*degrad:9:6);
            writeln(fo, '  exit  edge [deg] = ', cerex*degrad:9:6);
            writeln(fo, '  full gap   [mm]  = ', cgap*1000:8:3);
            writeln(fo, '  entry fringe K1  = ', cek1in:6:3);
            writeln(fo, '  exit  fringe K1  = ', cek1ex:6:3);
            writeln(fo, '  field B     [T]  = ', cphi/l*brho:9:5);
            writeln(fo, '  gradient B''[T/m] = ', ckq*brho:9:4);
            writeln(fo, '  curv. B"/2[T/m2] = ', cms*brho:9:4);
          end;
          cquad: begin
            writeln(fo); writeln(fo,Nam+': quadrupole');
            writeln(fo, '  length [m]       = ', l:9:6);
            writeln(fo, '  gradient B''[T/m] = ', kq*brho:9:4);
          end;
          csole: begin
            writeln(fo); writeln(fo,Nam+': solenoid');
            writeln(fo, '  length [m]       = ', l:9:6);
            writeln(fo, '  field B [T]      = ', 2*ks*brho:9:4);
          end;
          csext: begin
            writeln(fo); writeln(fo,Nam+': sextupole');
            if l=0 then writeln(fo, '  int B"/2*L [T/m] = ', ms*l*brho:9:3)
            else begin
              writeln(fo, '  length [m]       = ', l:9:6);
              writeln(fo, '  curv. B"/2[T/m2] = ', ms*brho:9:4);
            end;
          end;
          cmpol: begin
            if abs(nord)>7 then mnam:=inttostr(2*(abs(nord)))+'-mpole' else mnam:=mpolnam[abs(nord)];
            smpm:=inttostr(abs(nord)); smpm1:=inttostr(abs(nord)-1);  smpm2:=inttostr(abs(nord)-2);
            writeln(fo); writeln(fo,Nam+': '+mnam+' ( n = '+smpm+' )');
            if lmpol=0 then writeln(fo, '  B('+smpm1+')L/'+smpm1+'![T/m^'+smpm2+'] = ', bnl*brho:12:3)
            else begin
               writeln(fo, '  length [m]       = ', lmpol:9:6);
               writeln(fo, '  B('+smpm1+')/'+smpm1+'! [T/m^'+smpm1+'] = ', bnl/lmpol*brho:12:3)
            end;
          end;
          cundu: begin
            writeln(fo); write(fo,Nam+': undulator');
            if halfu then writeln(fo, ' (half) ') else writeln(fo, ' (full) ');
            writeln(fo, '  length [m]       = ', l:9:6);
            writeln(fo, '  period [mm]      = ', lam:9:6);
            writeln(fo, '  peak field [T]   = ', bmax:9:4);
            writeln(fo, '  full gap   [mm]  = ', ugap*1000:8:3);
            writeln(fo, '  fill factor B    = ', fill1:8:5);
            writeln(fo, '  fill factor B^2  = ', fill2:8:5);
            writeln(fo, '  fill factor B^3  = ', fill3:8:5);
          end;
          csept: begin
            writeln(fo); writeln(fo,Nam+': septum');
            writeln(fo, '  straight len.[m] = ', l:9:6);
            writeln(fo, '  distance   [mm]  = ', dis:9:6);
            writeln(fo, '  thickness  [mm]  = ', thk:9:6);
          end;
          ckick: begin
            writeln(fo); writeln(fo,Nam+': kicker');
            writeln(fo, '  length [m]       = ', l:9:6);
            writeln(fo, '  multipole order  = ', mpol:5);
            writeln(fo, '  kick at Xo [mrad]= ',amp:9:6);
            writeln(fo, '  ref.pos Xo [mm]  = ',xoff*1000:9:6);
            writeln(fo, '  half sine [nsec] = ',tau*1E9:9:3);
            writeln(fo, '  delay     [nsec] = ',delay*1E9:9:3);
          end;
          else;
        end;
      end;
    end;
    CloseFile(fo);
    MessageDlg('Magnet parameters written to '+fname, MtInformation, [mbOK],0);
  except
    on E: EInOutError do
    MessageDlg('Could not write '+fname+'. '+E.Message, MtError, [mbOK],0);
  end;
end;

procedure madseqconvert(seqfile: string; var TextBuffer: pointer);
// read expanded (no expressions) .seq file from madx
// yet incomplete and restricted to simple files
// as-6.1.2021

  type
    eletype=record
      nam: elemstr;
      len: real;
    end;
    seqtype=record
      iel: integer;
      pos: real;
    end;

  var
    inlin, s, seqline: string;
    tfIn: textfile;
    ifol, icom, i, k: integer;
//    mlin: TstringList;
    chpt: CharBufpt;
    firstchar: boolean;
    ich: integer;
    ele: array of eletype;
    seq: array of seqtype;
    drif: array of real;
    appflag: boolean;
    s1, s2, dis, seqlen: real;

    function extractval(lin, key1, key2 :string): real;
    // extract number from a string, finding delimiters before and after
    // --> should go to asaux, because it is of general use.
    var
      i1, i2, err: integer;
      xv: real;
      vstr: string;
    begin
      i1:=Pos(key1,lin)+length(key1);
      i2:=Pos(key2, copy(lin,i1,999));
      vstr:=Copy(lin,i1, i2-1);
 {$R-}
      Val(vstr,xv,err);
 {$R+}
      if err<>0 then xv:=0;
      extractval:=xv;
    end;

    // append a drift to the list, if > 1 micron and if we don't have yet a drift
    // of this length. Returns the drift index, -1 if zero length
    function appdri(dis:real):integer;
    const
      miceps=1e-6; //micron
    var
      k, kfnd: integer;
    begin
      kfnd:=-1;
      if abs(dis) > miceps then begin
        for k:=0 to High(drif) do if abs(dis-drif[k])<miceps then kfnd:=k;
        if kfnd = -1 then begin // not found, create new
          setlength(drif, length(drif)+1);
          drif[High(drif)]:=dis;
          kfnd:=High(drif);
        end;
      end;
      appdri:=kfnd;
    end;

    //append an element to the list, get name and length
    function appele (lin: string): boolean;
    var
      namin: string;
      lenin: real;
    begin
      namin:=copy(lin,0,pos(':',lin)-1);
      if length(namin)>1 then begin
        setlength(ele, Length(ele)+1);
        lenin:= extractval(lin,'l=',',');
        with ele[High(ele)] do begin
          nam:=namin; len:=lenin;
        end;
        appele:=true;
      end else appele:=false;
    end;

    // append an element name to the line up, but only if the element is known
    function appseq (lin: string): boolean;
    var
      namin: string;
      i1, i2, i, ifnd: integer;
      posin: real;
      fnd: boolean;
    begin
      i1:=Pos(':',lin)+1;
      i2:=Pos(',at=',lin);
      namin:=Copy(lin,i1, i2-i1);
      fnd:=false;
      for i:=0 to high(ele) do if (namin=ele[i].nam) then begin
        fnd:=true;
        ifnd:=i;
      end;
      if fnd then begin
        setlength(seq, Length(seq)+1);
        posin:=extractval(lin,'at=',';');
        with seq[High(seq)] do begin
          iel:=ifnd;
          pos:=posin;
        end;
        appseq:=true;
      end else begin
        appseq:=false;
      end;
    end;


  begin
    AssignFile(tfIn, seqfile);
    try
      reset(tfIn);
      // Keep reading lines until the end of the file is reached
      New(chpt);
      chpt.nex:=nil;
      firstchar:=true;
      inlin:='rtod='+ftos(degrad,12,8)+';';
      for ich:=1 to Length(inlin) do begin
        chpt:=AppendChar(chpt,inlin[ich]);
//        write(diagfil, chpt.ch);
        if firstchar then begin
          TextBuffer:=chpt;
          firstchar:=false;
        end
      end;
      ele:=nil;
      seq:=nil;
      inlin:='';
      while not eof(tfIn) do begin
        readln(tfIn, s);
        icom:=Pos('!',s);
        ifol:=Pos('&',s);
        if icom>0 then s:=Copy(s,1, icom-1);
        if ifol>0 then s:=Copy(s,1, ifol-1);
        inlin:=inlin+s;
        if ifol=0 then begin
          if length(inlin)>0 then begin
            appflag:=false;
            inlin:=LowerCase(DelSpace(inlin));

            // keyword at identifies entries in sequence list
            if Pos('at=',inlin)>0 then begin
              appseq(inlin);
            // special line, giving the total length of the sequence
            end else begin
              if Pos('sequence,', inlin) >0 then begin
                seqlen:=extractval(inlin,'l=',';');
              end;
              // check for element names, ignore unknowns
              // no interpretation except name and length, just copy content
              if Pos('sbend',inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin, 'sbend','bending');
                inlin:=AnsiReplaceText(inlin, 'angle=','t=rtod*');
                inlin:=AnsiReplaceText(inlin, 'e1=','t1=rtod*');
                inlin:=AnsiReplaceText(inlin, 'e2=','t2=rtod*');
                inlin:=AnsiReplaceText(inlin, 'k1=','k=');
                appflag:=appele(inlin);
              end;
              if Pos('quadrupole', inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin,'k1=','k=');
                appflag:=appele(inlin);

              end;
              if Pos('sextupole' , inlin)>0 then begin
                 inlin:=AnsiReplaceText(inlin,'k2=','k=1/2*');
                 appflag:=appele(inlin);
              end;
              if Pos('octupole',   inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin,'octupole','multipole, n=4');
                inlin:=AnsiReplaceText(inlin,'k3=','k=1/6*');
                appflag:=appele(inlin);
              end;
              if Pos('kicker',   inlin)>0 then begin
                // tmp handling of kickers
                inlin:=AnsiReplaceText(inlin, 'hkicker','kicker');
                inlin:=AnsiReplaceText(inlin, 'vkicker','kicker');
                appflag:=appele(inlin);
              end;
            end;
            if inlin[high(inlin)]<>';' then inlin:=inlin+';';
            //unknown elements are not imported
            if appflag then begin
              for ich:=1 to Length(inlin) do chpt:=AppendChar(chpt,inlin[ich]);
            end;
          end;
          inlin:='';
        end;
      end;
      CloseFile(tfIn);

      // create drift spaces from distances in sequence
      // assuming that all positions refer to the center of the element
      // !! careful: madx allows alternative definitions
      // create a new sequence including drifts
      drif:=nil;
      seqline:='';
      s1:=0.0;
      for i:=0 to high(seq) do with seq[i] do begin
        s2:= pos - ele[iel].len/2; //entry
        dis:=s2-s1;
        k:=appdri(dis); //get index of drift
        if k>-1 then seqline:=seqline+', d'+copy(inttostr(10000+k),2,4);
        seqline:=seqline+', '+ele[iel].nam;
        s1:=s2+ele[iel].len; //exit
      end;
      dis:=seqlen-s1;
      k:=appdri(dis);
      if k>-1 then seqline:=seqline+', d'+copy(inttostr(10000+k),2,4);
      seqline:='line : '+copy(seqline,2)+';';

      //import the new created drifts
      for k:=0 to high(drif) do begin
        inlin:='d'+copy(inttostr(10000+k),2,4)+': drift, l='+ftos(drif[k],10,6)+';';
        for ich:=1 to Length(inlin) do chpt:=AppendChar(chpt,inlin[ich]);
      end;

      // import the new sequence
      for ich:=1 to Length(seqline) do chpt:=AppendChar(chpt,seqline[ich]);

    except
      on E: EInOutError do
       opaLog(1, 'File handling error occurred. Details: '+E.Message);
    end;

end;


procedure madconvert(madfile: string; var TextBuffer: pointer);
// read mad file, yet incomplete and restricted to simple files

  var
    inlin, s: string;
    tfIn: textfile;
    ifol, icom: integer;
//    mlin: TstringList;
    chpt: CharBufpt;
    firstchar: boolean;
    ich: integer;

  begin
    AssignFile(tfIn, madfile);
    // Embed the file handling in a try/except block to handle errors gracefully
    try
      reset(tfIn);
      // Keep reading lines until the end of the file is reached
//      mlin:=TStringList.Create;
      New(chpt);
      chpt.nex:=nil;
      firstchar:=true;
      inlin:='rtod='+ftos(degrad,12,8)+';';
      for ich:=1 to Length(inlin) do begin
        chpt:=AppendChar(chpt,inlin[ich]);
        if firstchar then begin
          TextBuffer:=chpt;
          firstchar:=false;
        end
      end;
      inlin:='';
      while not eof(tfIn) do begin
        readln(tfIn, s);
        icom:=Pos('!',s);
        ifol:=Pos('&',s);
        if icom>0 then s:=Copy(s,1, icom-1);
        if ifol>0 then s:=Copy(s,1, ifol-1);
        inlin:=inlin+s;
        if ifol=0 then begin
          if length(inlin)>0 then begin
            inlin:=LowerCase(DelSpace(inlin));
            if Pos('line=',inlin)>0 then begin
              inlin:=AnsiReplaceText(inlin, 'line=(','');
              inlin:=AnsiReplaceText(inlin, ')','');
//              inlin:=Copy(inlin,1,length(inlin)-2);
            end else begin
              if Pos('sbend',inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin, 'sbend','bending');
                inlin:=AnsiReplaceText(inlin, 'angle=','t=rtod*');
                inlin:=AnsiReplaceText(inlin, 'e1=','t1=rtod*');
                inlin:=AnsiReplaceText(inlin, 'e2=','t2=rtod*');
                inlin:=AnsiReplaceText(inlin, 'k1=','k=');
              end;
              if Pos('quadrupole', inlin)>0 then inlin:=AnsiReplaceText(inlin,'k1=','k=');
              if Pos('sextupole' , inlin)>0 then inlin:=AnsiReplaceText(inlin,'k2=','k=1/2*');
              if Pos('octupole',   inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin,'octupole','multipole, n=4');
                inlin:=AnsiReplaceText(inlin,'k3=','k=1/6*');
              end;
            end;
            if inlin[high(inlin)]<>';' then inlin:=inlin+';';
//            writeln(diagfil);
            for ich:=1 to Length(inlin) do begin
              chpt:=AppendChar(chpt,inlin[ich]);
            end;
//            mlin.add(inlin);
//            writeln(diagfil, inttostr(mlin.Count)+' '+mlin[mlin.Count-1]);
          end;
          inlin:='';
        end;
      end;

//      mlin.Free;
      CloseFile(tfIn);
    except
      on E: EInOutError do
       opalog(1, 'File handling error occurred. Details: '+E.Message);
    end;

end;


procedure lteconvert(ltefile: string; var TextBuffer: pointer);
// read elegant lte file, yet incomplete and restricted to simple files

  var
    inlin, s: string;
    tfIn: textfile;
    ifol, icom: integer;
//    mlin: TstringList;
    chpt: CharBufpt;
    firstchar: boolean;
    isto, ipop, ich: integer;

  begin
    AssignFile(tfIn, ltefile);
    // Embed the file handling in a try/except block to handle errors gracefully
    try
      reset(tfIn);
      // Keep reading lines until the end of the file is reached
//      mlin:=TStringList.Create;
      New(chpt);
      chpt.nex:=nil;
      firstchar:=true;
      inlin:='rtod='+ftos(degrad,12,8)+';';
      for ich:=1 to Length(inlin) do begin
        chpt:=AppendChar(chpt,inlin[ich]);
//        write(diagfil, chpt.ch);
        if firstchar then begin
          TextBuffer:=chpt;
          firstchar:=false;
        end
      end;
      inlin:='';
      while not eof(tfIn) do begin
        readln(tfIn, s);
        icom:=Pos('!',s);
        ifol:=Pos('&',s);
        if icom>0 then s:=Copy(s,1, icom-1);
        if ifol>0 then s:=Copy(s,1, ifol-1);
        inlin:=inlin+s;
        if ifol=0 then begin
          if length(inlin)>0 then begin
            inlin:=LowerCase(DelSpace(inlin));
            if Pos('%',inlin)=1 then begin
              // variable definitions
              isto:=Pos('sto',inlin); ipop:=Pos('pop',inlin);
              if (isto>0) and (ipop>0) then begin
                inlin:=copy(inlin,isto+3,ipop-isto-3)+'='+copy(inlin,2,isto-2);
              end;
            end
            else if Pos('line=',inlin)>0 then begin
              inlin:=AnsiReplaceText(inlin, 'line=(','');
              inlin:=AnsiReplaceText(inlin, ')','');
//              inlin:=Copy(inlin,1,length(inlin)-2);
            end else begin
              if Pos('bend',inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin, 'csbend','bending');
                inlin:=AnsiReplaceText(inlin, 'ccbend','{CC} combined');
                inlin:=AnsiReplaceText(inlin, 'angle=','t=rtod*');
                inlin:=AnsiReplaceText(inlin, 'e1=','t1=rtod*');
                inlin:=AnsiReplaceText(inlin, 'e2=','t2=rtod*');
                inlin:=AnsiReplaceText(inlin, 'hgap=','gap=2000*');
                inlin:=AnsiReplaceText(inlin, 'k1=','k='); //this first!
                inlin:=AnsiReplaceText(inlin, 'fint=','k1=');
              end
              else if Pos('kquad', inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin,'kquad','quadrupole');
                inlin:=AnsiReplaceText(inlin,'k1=','k=');
              end
              else if Pos('quad', inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin,'quad','quadrupole');
                inlin:=AnsiReplaceText(inlin,'k1=','k=');
              end
              else if Pos('edrift,' , inlin)>0 then inlin:=AnsiReplaceText(inlin,'edrift,','drift,')
              else if Pos('drif,' , inlin)>0 then inlin:=AnsiReplaceText(inlin,'drif,','drift,')
              else if Pos('ksext' , inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin,'ksext','sextupole');
                inlin:=AnsiReplaceText(inlin,'k2=','k=1/2*');
              end
              else if Pos('mult',   inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin,'mult','multipole');
                inlin:=AnsiReplaceText(inlin,'order=','n=');
     //to do: read order from file and insert factorial
                inlin:=AnsiReplaceText(inlin,'knl=','{div by factorial!}k=');
              end
              else if Pos('kicker',inlin)>0 then {nothing, but hkick appears as property in kicker}
              else if Pos('hkick',inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin,'hkick,','h-corrector,');
                inlin:=AnsiReplaceText(inlin,'kick=,','k=,');
              end
              else if Pos('vkick',inlin)>0 then begin
                inlin:=AnsiReplaceText(inlin,'vkick,','v-corrector,');
                inlin:=AnsiReplaceText(inlin,'kick=,','k=,');
              end
            end;
            if inlin[high(inlin)]<>';' then inlin:=inlin+';';
//            writeln(diagfil);
            for ich:=1 to Length(inlin) do begin
              chpt:=AppendChar(chpt,inlin[ich]);
//              write(diagfil, chpt.ch);
            end;
//            mlin.add(inlin);
//            writeln(diagfil, inttostr(mlin.Count)+' '+mlin[mlin.Count-1]);
          end;
          inlin:='';
        end;
      end;

//      mlin.Free;
      CloseFile(tfIn);
    except
      on E: EInOutError do
       opalog(1, 'File handling error occurred. Details: '+E.Message);
    end;

end;

procedure undulator_export;
// starting an export to SPECTRA code, incomplete
// undu HAS to be defined in 2 halfs: UND,x,y,z,-UND with option HALF in undulator, and x,y,z length=0 elements
var
  i, iupre, jel, npole: integer;
  {Emitx, Emity, }lamu, kvalx, kvaly, itot, coup: real;
  fsp: textfile;
  fnam, fnam0: string;

begin
  // check status, periodic, undulators, etc.
  // assume that a solution for the lattice, betas etc, exists



  AllocOpval;
  MomMode:=False;
  ncurves:=0;
  //Permode:=True;
  // start forward from initial values, whatever they are:
  Linop(0,0,do_twiss+do_radin, 0.0);

  coup:=FDefGet('trackt/coup')/100;
  itot:=FDefGet('trackt/itot');

  fnam:=ExtractFileName(FileName);
  fnam0:=Copy(fnam,0,Pos('.',fnam)-1);
  fnam:=work_dir+fnam0+'.prm';
  assignFile(fsp, fnam);
  try
    rewrite(fsp);
    writeln(fsp, '[ACCELERATOR]');
    writeln(fsp, 'Name    ',fnam0);
    writeln(fsp, 'eGeV    ', Glob.Energy:6:3);
    writeln(fsp, 'imA     ',itot:6:3);
    with oBeam[0] do begin
      if not status.uncoupled then coup:=Emitb/Emita;
// (temp solution, spectra uses simple coupling model neglecting Jx,Jy)
      writeln(fsp, 'cirm    ', circ:9:3);
      writeln(fsp, 'emitt   ', ftos(Emita,-4,6));
      writeln(fsp, 'coupl    ',abs(coup):9:7);
      writeln(fsp, 'espread ', sigmaE:9:7);
    end;
    iupre:=-1;
    writeln(fsp, '[SOURCE]');
    for i:=1 to Glob.NLatt do begin
      jel:=findel(i);
      if Ella[jel].cod=cundu then begin
        if iupre = -1 then iupre:=i else begin //found 2nd half of undu, no l>0 elements between
          jel:=findel(iupre);// do the export  after iupre
          with Ella[jel] do begin
            writeln(fsp, 'Name    ', nam);
            //writeln(diagfil, jel,' ', iupre, ' ', i, ' ',ella[jel].nam);
            npole:=round(2*l/lam);
            lamu:=2*l/npole;
            kvaly:=bmax*lamu/2/pi/electron_mc2*speed_of_light;
            kvalx:=0;
            //opa uses implicitly "end correction magnets" option of Spectra
            writeln(fsp, 'length ',2*l-2*lamu:6:3);
            writeln(fsp, 'lu     ',lamu*100:6:3);
            writeln(fsp, 'kx     ',kvalx:6:3);
            writeln(fsp, 'ky     ',kvaly:6:3);
            writeln(fsp, 'gap    ',ugap*1000:6:3);
          end;
          with Opval[0,iupre] do begin
            //writeln(fsp, 'spos ',spos:8:3);
            writeln(fsp, 'betax   ',beta:8:4);
            writeln(fsp, 'alphax  ',alfa:8:4);
            writeln(fsp, 'betay   ',betb:8:4);
            writeln(fsp, 'alphay  ',alfb:8:4);
            writeln(fsp, 'eta     ',disx:8:5);
            writeln(fsp, 'deta    ',dipx:8:5);
            writeln(fsp, 'etay    ',disy:8:5);
            writeln(fsp, 'detay   ',dipy:8:5);
          end;
          writeln(fsp, '----------------------------------------------------------');
        end;
      end else if Ella[jel].l > 0 then iupre:=-1;
    end;
    CloseFile(fsp);
  except
    on E: EInOutError do opaLog(1, 'File handling error occurred. Details: '+E.Message);
  end;
end;




// yet incomplete export of bd patterms to masamitsu's master generator June 2020
procedure bdpattern_export;
var
  fbd: textfile;
  fnam: string;
  ic,j: integer;
  icfound: boolean;
  snam: string;
begin
  fnam:=ExtractFileName(FileName);
  fnam:=Copy(fnam,0,Pos('.',fnam)-1);
  fnam:=work_dir+'BDpattern.'+fnam+'.py';
  assignFile(fbd, fnam);
  try
    rewrite(fbd);

    for ic:=0 to Nelemkind do begin
      icfound:=false;
      for j:=1 to Glob.NElem do begin
        with elem[j] do begin
          if cod=ic then begin
            icfound:=true;
            snam:=Elem[j].nam;
            snam:='Strength['''+snam+''']=';
            case cod of
              cquad: writeln(fbd,snam+FtoS(kq,12,9));
              cbend: writeln(fbd,snam+FtoS(kb,12,9));
              csext: writeln(fbd,snam+FtoS(ms,12,9)); // always l>0
              ckick: ;
              csept: ;
              ccomb: writeln(fbd,snam+FtoS(ckq,12,9));
              cmpol: writeln(fbd,snam+FtoS(bnl,12,7));
              else; //nothing
            end;
          end;
        end;
      end;
      if icfound then writeln(fbd);
    end;

    CloseFile(fbd);
  except
    on E: EInOutError do
      opaLog(1, 'File handling error occurred. Details: '+E.Message);
  end;
end;

procedure ele_aper_export;
//aperture export to elegant (perhaps include automatically in elegant export)
var
  fap: textfile;
  fnam: string;
  i,j: integer;
  spos: double;
begin
  fnam:=ExtractFileName(FileName);
  fnam:=Copy(fnam,0,Pos('.',fnam)-1);
  fnam:=work_dir+fnam+'_'+Segm[iactseg].nam+'.ap';
  assignFile(fap, fnam);
  try
    rewrite(fap);
    writeln(fap, 'SDDS1ASTRA2ELEGANT2003');
    writeln(fap, '&column name=s, units=m, type=double, &end');
    writeln(fap, '&column name=xHalfAperture, units=m, type=double, &end');
    writeln(fap, '&column name=yHalfAperture, units=m, type=double, &end');
    writeln(fap, '&column name=xCenter, units=m, type=double, &end');
    writeln(fap, '&column name=yCenter, units=m, type=double, &end');
    writeln(fap, '&data mode=ascii, &end');
    writeln(fap, '! page number 1');

    writeln(fap, Glob.NLatt*2);
    spos:=0;
    for i:=1 to Glob.Nlatt do begin
      j:=Findel(i);
      with Ella[j] do begin
        writeln(fap, spos, ax*1e-3, ay*1e-3, ' 0.0 0.0');
        spos:=spos+l;
        writeln(fap, spos, ax*1e-3, ay*1e-3, ' 0.0 0.0');
      end;
    end;
    CloseFile(fap);
  except
    on E: EInOutError do
      opaLog(1, 'File handling error occurred. Details: '+E.Message);
  end;
end;




{ ************* DEAD BODIES ********************** }


{
// das war nur eine Tabellierung der Touschek Funktion --> kann weg
procedure Ctouschek_table;
var
  i, n: integer;
  z: double;

begin
  n:=1000;
  for i:=0 to n do begin
    z:=PowR(10,-3.5+5.5*i/n);
    writeln(diagfil,z, Ctouschek(z), Ctouschek_pol(z));
  end;
end;
}

{
// test der Euler Winkel --> kann weg
procedure Eulertest;
var
  rom: matrix_3;
  ainy, ainx, ains, ay, ax, ass: double;
begin
  ainy:=12;
  ainx:=90;
  ains:=13;

  rom:=MatMul3(RotMat3(1,raddeg*ains), MatMul3(RotMat3(2,raddeg*ainx), RotMat3(3,raddeg*ainy)));
  EulerAng(rom, ay, ax, ass, false);
  writeln(diagfil, 'input ', ainy:8:2, ainx:8:2, ains:8:2);
  writeln(diagfil, 'eulr1 ', ay*degrad:8:2, ax*degrad:8:2, ass*degrad:8:2);
  EulerAng(rom, ay, ax, ass, true);
  writeln(diagfil, 'eulr2 ', ay*degrad:8:2, ax*degrad:8:2, ass*degrad:8:2);
  writeln(diagfil);
  printmat3(rom);
  writeln(diagfil);


end;
}

{ *** discontinued ***
// Stupid start for kicker bump - should be implemented by setting reference orbit.
procedure kickerbump3;
// set up 3 kicker bump for horiz inject: input x offset at marker 'inject' (after 2nd kicker, if not present)
// straightforward to generalize to 4 kickers, giving x and x' as inputs
// --> integrate into injection simulation, check delays

var
  ikick: array of integer;
  i,j,itmp,ipinj,ipinpos: integer;
  a, b, d: matrix_2;
  denom, dinj, xoff, temp, xpang:double;
  k: array[0..2] of double;

// may be useful elsewhere too: matrix from a to b (not including a, but including b)
  function getmatAB (ia, ib: integer): Matrix_2;
  var
    j: word;
    i: integer;
  begin
    TransferMatrix:=Unit_Matrix_5;
    if ia<ib then begin
      for i:=ia+1 to ib do Lattel(i, j, 0, 0);
    end else begin
      for i:=ia+1 to Glob.NLatt do Lattel(i,j,0,0);
      for i:=1 to ib do Lattel(i,j,0,0);
    end;
    getmatAB:=MatCut52(Transfermatrix,1,1);
  end;

begin
  ikick:=nil;
  ipinj:=-1;

// find kickers and point of injection
  for i:=1 to Glob.NLatt do begin
    j:=findel(i);
    with Ella[j] do begin
      if cod=ckick then begin
        setlength(ikick, Length(ikick)+1);
        ikick[High(ikick)]:=i;
      end else if (cod=cmark) and (CompareText(nam, 'inject')=0) then ipinj:=i;
    end;
  end;

  if Length(ikick)=3 then begin
// sort kickers and injection point, since lattice may start/end inside kicker bump
// inject point can be between K1 and K2 or between K2 and K3
    if (ikick[1]-ikick[0]) > Glob.NLatt div 2 then begin // two at end, one (k3) at start
      itmp:=ikick[0]; ikick[0]:=ikick[1]; ikick[1]:=ikick[2]; ikick[2]:=itmp;
      if (ipinj-ikick[0])*(ipinj-ikick[1])<0 then ipinpos:=-1
      else if (ipinj > ikick[1]) or (ipinj < ikick[2]) then ipinpos:=1
      else ipinpos:=0;
    end else if (ikick[2]-ikick[1])> Glob.NLatt div 2 then begin // one (k1) at end, two at start
      itmp:=ikick[2]; ikick[2]:=ikick[1]; ikick[1]:=ikick[0]; ikick[0]:=itmp;
      if (ipinj-ikick[1])*(ipinj-ikick[2])<0 then ipinpos:=1
      else if (ipinj< ikick[1]) or (ipinj > ikick[0]) then ipinpos:=-1
      else ipinpos:=0
    end else begin  // else assume correct order
      if (ipinj-ikick[0])*(ipinj-ikick[1])<0 then ipinpos:=-1 //between 0 and 1
      else if (ipinj-ikick[1])*(ipinj-ikick[2])<0 then ipinpos:=1 // between 1 and 2
      else ipinpos:=0; // outside bump, invalid
    end;
    if ipinj=-1 then ipinpos:=0; // correct misidentification in case of no marker
    for i:=0 to High(ikick) do writeln(diagfil,'Kicker ',i+1,' at ', ikick[i]);
    writeln  (diagfil,'Injection marker at', ipinj, ' ipinpos = ', ipinpos);
// calculate kicker angles and injected beam angle
    a:=getmatab(ikick[0],ikick[1]-1);
    b:=getmatab(ikick[1],ikick[2]-1);
    temp:=b[1,1]*a[1,2]+b[1,2]*a[2,2];
    if ipinpos=1 then begin
      d:=getmatab(ikick[1], ipinj-1);
      denom:=b[1,2]*(d[1,1]*a[1,2]+d[1,2]*a[2,2])-d[1,2]*temp;
    end else  if ipinpos=-1 then begin
      d:=getmatab(ikick[0], ipinj-1);
      denom:=b[1,2]*d[1,2];
    end else begin   // assume K2 exit if nothing was given
      denom:=b[1,2]*a[1,2];
    end;
    xoff:=-0.007; // offset in x at K2
    if abs(denom)>1e-8 then begin
      k[0]:=b[1,2]*xoff/denom;
      k[1]:=-temp*xoff/denom;
      k[2]:=-(b[2,1]*a[1,2]+b[2,2]*a[2,2])*k[0]-b[2,2]*k[1];
      case ipinpos of
      -1:  xpang:=d[2,2]*k[0];
       0:  xpang:=k[1]+a[2,2]*k[0];
       1:  xpang:=d[2,1]*a[1,2]*k[0]+d[2,2]*(k[1]+a[2,2]*k[0]);
      end;
      for i:=0 to 2 do begin
        j:=findel(ikick[i]); Ella[j].amp:=k[i];
      end;
      writeln(diagfil, 'kicker strengths, pos and angle = ', k[0], k[1], k[2], xoff, xpang);
    end else writeln(diagfil, 'no solution found for kicker bump');
  end else writeln(diagfil, 'found ', Length(ikick),' kickers instead of 3. stop.');

end;
}


{
// 3D output fuer Volkers plot programm --> kann weg
procedure VZlineup;
var
  val: array[1..6] of real;
  i,k,j:integer;
  fot: textfile;
  fnam: string;
  ds, dx, angy, can, san, leng, sang: real;
  rm, orm, orm0, test: matrix_3;
  dir, vor, tra, otra: vektor_3;
begin
  fnam:=ExtractFileName(FileName);
  fnam:=work_dir+Copy(fnam,0,Pos('.',fnam)-1);
  fnam:=fnam+'_lineup.txt';
  AssignFile(fot,fnam);
//$I-
//  rewrite(fot);
// $I+
  for i:=0 to NElemkind do begin
    writeln(fot,'#',i:3,' = ',ElemName[i]);
  end;


  writeln(fot,'#cod        L[m]     angle[rad]   edge_in[rad]   edge_ot[rad]      b2 [1/m2]      b3 [1/m3]     b4L [1/m3]  pc[GeV]  Name');
  for i:=0 to Glob.Nlatt do begin
    j:=Findel(i);
    for k:=1 to 6 do val[k]:=0;
    with Ella[j] do begin
      case cod of
        cquad: val[4]:=kq;
        cbend: begin
                 val[1]:=phi;
                 if Lattice[i].inv =1 then begin
                   val[2]:=tin; val[3]:=tex;
                 end else begin
                   val[2]:=tex; val[3]:=tin;
                 end;
                 val[4]:=kb;
               end;
        csext: val[5]:=ms;
        ccomb: begin
                 val[1]:=cphi;
                 if Lattice[i].inv =1 then begin
                   val[2]:=cerin; val[3]:=cerex;
                 end else begin
                   val[2]:=cerex; val[3]:=cerin;
                 end;
                 val[4]:=ckq;
               end;
        cmpol: val[6]:=bnl;
        crota: val[1]:=rot;
        else begin end;
      end;
      write(fot, cod:4, l:12:6);
      for k:=1 to 6 do write(fot, val[k]:15:8);
      writeln(fot,glob.energy:9:3,'  ',nam);
    end;
  end;

  writeln(fot,'#cod        x[m]          [y[m]           z[m]          dir-x          dir-y          dir-z     L[m]            s[m]     angle[rad]  Name');

  orm:=MatUni3; orm0:=MatUni3;
  dir[1]:=0; dir[2]:=0; dir[3]:=1; //direction vector x,y,s
  for k:=1 to 3 do vor[k]:=0;
  leng:=0;  sang:=0;
  for i:=0 to Glob.Nlatt do begin
    for k:=1 to 3 do tra[k]:=0;
    j:=Findel(i);
    with Ella[j] do begin
      if l<>0 then begin
        tra[3]:=l;
        if cod in [cbend, ccomb] then begin
// bend = rotation around y
          if cod=cbend then angy:=phi else angy:=cphi;
          if angy <> 0 then begin
            sang:=sang+angy;
            can:=cos(angy); san:=sin(angy);
            tra[3]:=san*l/angy; tra[1]:=-(1-can)*l/angy;
            rm:=MatUni3;
            rm[1,1]:=can; rm[3,3]:=can; rm[1,3]:=-san; rm[3,1]:=san;
            orm:=MatMul3(rm, orm0);
            dir:=LinTra3(rm, dir);
//            ormi:=MatInv3(orm); //not needed
          end;
        end;
        leng:=leng+l;
        vor:=VecAdd3(vor,Lintra3(orm0,tra)); //translation to end of element
//        writeln(fot,ella[j].cod, vor[1]:15:8,vor[2]:15:8, vor[3]:15:8, dir[1]:15:8,dir[2]:15:8,dir[3]:15:8, l:10:3, leng:15:6, sang:15:8, '  ', nam);
        writeln(fot,ella[j].cod, vor[1]:15:8,vor[2]:15:8, vor[3]:15:8, orm0[1,3]:15:8,orm0[2,3]:15:8,orm0[3,3]:15:8, l:10:3, leng:15:6, sang:15:8, '  ', nam);
      end else if cod = crota then begin
        if rot<>0 then begin
// rotation around s
          can:=cos(rot); san:=sin(rot);
writeln(fot, 'rotation ', rot*degrad:15:8);
          rm:=MatUni3;
          rm[1,1]:=can; rm[2,2]:=can; rm[1,2]:=san; rm[2,1]:=-san;
          orm:=MatMul3(rm, orm0);
          dir:=LinTra3(rm, dir);
        end;
      end;
      orm0:=orm;
     end; //with
  end;

  closefile(fot);
end;
}


{
// wofuer war das nochmal gut?
procedure indexxtest;
const n=10000;
var
  x: array of real;
  i: array of integer;
  k: integer;
  fail: boolean;
begin

  setlength(x,n);
  setlength(i,n);
  Randomize;
  for k:=0 to n-1 do x[k]:=random;
  indexx(x,i);
  fail:=false;
  for k:=1 to n-1 do fail:=fail or (x[i[k]]<x[i[k-1]]);
  writeln(diagfil,fail);
  for k:=0 to n-1 do  writeln(diagfil,x[k], x[i[k]]);
end;
}

{
//only a test for efficient calculation of binominal coefficients, not used in OPA.
//becomes wrong for very large numbers, probably due to round-off, to be improved using other data types.
//but ok tested for n~50
function combination(n,k: integer): double;
var
  g,s,i: integer; x: double;
begin
  if k > n /2 then begin
    g:=k; s:=n-k;
  end else begin
     g:=n-k; s:=k;
  end;
  if s < 0 then combination:=0 else if s = 0 then combination:=1 else begin
    x:=1;
    for i:=1 to s do begin
      x:=x*(g+i);
      x:=x/i;
    end;
    combination:=x;
  end;
end;
}


end.
